Index: /branches/DEV_r2006_merge_TRA_TRC/NEMO/OPA_SRC/step.F90
===================================================================
--- /branches/DEV_r2006_merge_TRA_TRC/NEMO/OPA_SRC/step.F90	(revision 2081)
+++ /branches/DEV_r2006_merge_TRA_TRC/NEMO/OPA_SRC/step.F90	(revision 2082)
@@ -105,6 +105,6 @@
       ! Ocean physics update                (ua, va, ta, sa used as workspace)
       !<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
-                         CALL bn2( tb, sb, rn2b )     ! before Brunt-Vaisala frequency
-                         CALL bn2( tn, sn, rn2  )     ! now    Brunt-Vaisala frequency
+                         CALL bn2( tsb, rn2b )        ! before Brunt-Vaisala frequency
+                         CALL bn2( tsn, rn2  )        ! now    Brunt-Vaisala frequency
       !
       !  VERTICAL PHYSICS   
@@ -137,8 +137,7 @@
       !
       IF( lk_ldfslp ) THEN                            ! slope of lateral mixing
-                         CALL eos( tb, sb, rhd )                ! before in situ density
-         IF( ln_zps )    CALL zps_hde( kstp, tb, sb, rhd,  &    ! Partial steps: before horizontal gradient
-            &                              gtu, gsu, gru,  &    ! of t, s, rd at the last ocean level
-            &                              gtv, gsv, grv )
+                         CALL eos( tsb, rhd )                ! before in situ density
+         IF( ln_zps )    CALL zps_hde( kstp, jpts, tsb, gtsu, gtsv,  &    ! Partial steps: before horizontal gradient
+            &                                      rhd, gru , grv  )      ! of t, s, rd at the last ocean level
                          CALL ldf_slp( kstp, rhd, rn2b )        ! before slope of the lateral mixing
       ENDIF
@@ -169,8 +168,6 @@
       ! Active tracers                              (ua, va used as workspace)
       !<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
-                             ta(:,:,:) = 0.e0               ! set tracer trends to zero
-                             sa(:,:,:) = 0.e0
-
-                             CALL tra_swap
+                             tsa(:,:,:,:) = 0.e0               ! set tracer trends to zero
+
                              CALL tra_sbc    ( kstp )       ! surface boundary condition
       IF( ln_traqsr      )   CALL tra_qsr    ( kstp )       ! penetrative solar radiation qsr
@@ -192,21 +189,16 @@
          IF( ln_zdfnpc   )   CALL tra_npc    ( kstp )            ! update after fields by non-penetrative convection
                              CALL tra_nxt    ( kstp )            ! tracer fields at next time step
-                             CALL tra_unswap
-                             CALL eos( ta, sa, rhd, rhop )       ! Time-filtered in situ density for hpg computation
-         IF( ln_zps      )   CALL zps_hde( kstp, ta, sa, rhd,   &   ! Partial steps: time filtered hor. derivative
-            &                                   gtu, gsu, gru,  &   ! of t, s, rd at the bottom ocean level
-            &                                   gtv, gsv, grv )
+                             CALL eos( tsa, rhd, rhop )       ! Time-filtered in situ density for hpg computation
+         IF( ln_zps      )   CALL zps_hde( kstp, jpts, tsa, gtsu, gtsv,  &    ! Partial steps: time filtered hor. derivative
+            &                                          rhd, gru , grv  )      ! of t, s, rd at the last ocean level
          
       ELSE                                                  ! centered hpg  (eos then time stepping)
-                             CALL tra_unswap
-                             CALL eos( tn, sn, rhd, rhop )       ! now in situ density for hpg computation
-         IF( ln_zps      )   CALL zps_hde( kstp, tn, sn, rhd,   &   ! Partial steps: now horizontal derivative
-            &                                   gtu, gsu, gru,  &   ! of t, s, rd at the bottom ocean level
-            &                                   gtv, gsv, grv )
-                             CALL tra_swap
+                             CALL eos( tsn, rhd, rhop )       ! now in situ density for hpg computation
+         IF( ln_zps      )   CALL zps_hde( kstp, jpts, tsn, gtsu, gtsv,  &    ! Partial steps: now hor. derivative
+            &                                          rhd, gru , grv  )      ! of t, s, rd at the last ocean level
          IF( ln_zdfnpc   )   CALL tra_npc    ( kstp )       ! update after fields by non-penetrative convection
                              CALL tra_nxt    ( kstp )       ! tracer fields at next time step
+      ENDIF 
                              CALL tra_unswap
-      ENDIF 
 
       !>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
Index: /branches/DEV_r2006_merge_TRA_TRC/NEMO/OPA_SRC/step_oce.F90
===================================================================
--- /branches/DEV_r2006_merge_TRA_TRC/NEMO/OPA_SRC/step_oce.F90	(revision 2081)
+++ /branches/DEV_r2006_merge_TRA_TRC/NEMO/OPA_SRC/step_oce.F90	(revision 2082)
@@ -81,4 +81,5 @@
    USE trdmld_rst      ! restart for mixed-layer trends
    USE trdmod_oce      ! ocean momentum/tracers trends
+   USE trdmod          ! momentum/tracers trends   
    USE trdvor          ! vorticity budget                 (trd_vor routine)
    USE diagap          ! hor. mean model-data gap         (dia_gap routine)
Index: /branches/DEV_r2006_merge_TRA_TRC/NEMO/OPA_SRC/trc_oce.F90
===================================================================
--- /branches/DEV_r2006_merge_TRA_TRC/NEMO/OPA_SRC/trc_oce.F90	(revision 2081)
+++ /branches/DEV_r2006_merge_TRA_TRC/NEMO/OPA_SRC/trc_oce.F90	(revision 2082)
@@ -20,5 +20,8 @@
    PUBLIC   trc_oce_rgb_read   ! routine called by traqsr.F90
    PUBLIC   trc_oce_ext_lev    ! function called by traqsr.F90 at least
-   
+ 
+   INTEGER , PUBLIC  ::  nn_dttrc      !: frequency of step on passive tracers
+   INTEGER , PUBLIC  ::  nittrc000     !: first time step of passive tracers model
+  
    REAL(wp), PUBLIC , DIMENSION(jpi,jpj,jpk) ::   etot3   !: light absortion coefficient
 
Index: /branches/DEV_r2006_merge_TRA_TRC/NEMO/TOP_SRC/C14b/trcsms_c14b.F90
===================================================================
--- /branches/DEV_r2006_merge_TRA_TRC/NEMO/TOP_SRC/C14b/trcsms_c14b.F90	(revision 2081)
+++ /branches/DEV_r2006_merge_TRA_TRC/NEMO/TOP_SRC/C14b/trcsms_c14b.F90	(revision 2082)
@@ -234,7 +234,7 @@
             !  Computation of solubility  
             IF (tmask(ji,jj,1) >  0.) THEN
-               ztp  = ( tn(ji,jj,1) + 273.16 ) * 0.01
+               ztp  = ( tsn(ji,jj,1,jp_tem) + 273.16 ) * 0.01
                zsk  = 0.023517 + ztp * ( -0.023656 + 0.0047036 * ztp )
-               zsol = EXP( -60.2409 + 93.4517 / ztp  + 23.3585 * LOG( ztp ) + zsk * sn(ji,jj,1) )
+               zsol = EXP( -60.2409 + 93.4517 / ztp  + 23.3585 * LOG( ztp ) + zsk * tsn(ji,jj,1,jp_sal) )
                ! convert solubilities [mol/(l * atm)] -> [mol/(m^3 * ppm)]
                zsol = zsol * 1.0e-03
@@ -247,5 +247,5 @@
 
             ! Computes the Schmidt number of CO2 in seawater
-            zt   = tn(ji,jj,1)
+            zt   = tsn(ji,jj,1,jp_tem)
             zsch = 2073.1 + zt * ( -125.62 + zt * (3.6276 - 0.043219 * zt ) )
 
Index: /branches/DEV_r2006_merge_TRA_TRC/NEMO/TOP_SRC/CFC/trcsms_cfc.F90
===================================================================
--- /branches/DEV_r2006_merge_TRA_TRC/NEMO/TOP_SRC/CFC/trcsms_cfc.F90	(revision 2081)
+++ /branches/DEV_r2006_merge_TRA_TRC/NEMO/TOP_SRC/CFC/trcsms_cfc.F90	(revision 2082)
@@ -129,8 +129,8 @@
                ! coefficient for solubility for CFC-11/12 in  mol/l/atm
                IF( tmask(ji,jj,1) .GE. 0.5 ) THEN
-                  ztap  = ( tn(ji,jj,1) + 273.16 ) * 0.01
+                  ztap  = ( tsn(ji,jj,1,jp_tem) + 273.16 ) * 0.01
                   zdtap = sob(1,jl) + ztap * ( sob(2,jl) + ztap * sob(3,jl) ) 
                   zsol  =  EXP( soa(1,jl) + soa(2,jl) / ztap + soa(3,jl) * LOG( ztap )   &
-                     &                    + soa(4,jl) * ztap * ztap + sn(ji,jj,1) * zdtap ) 
+                     &                    + soa(4,jl) * ztap * ztap + tsn(ji,jj,1,jp_sal) * zdtap ) 
                ELSE
                   zsol  = 0.e0
@@ -143,5 +143,5 @@
                ! Computation of speed transfert
                !    Schmidt number
-               zt1  = tn(ji,jj,1)
+               zt1  = tsn(ji,jj,1,jp_tem)
                zt2  = zt1 * zt1 
                zt3  = zt1 * zt2
Index: /branches/DEV_r2006_merge_TRA_TRC/NEMO/TOP_SRC/LOBSTER/trcbio.F90
===================================================================
--- /branches/DEV_r2006_merge_TRA_TRC/NEMO/TOP_SRC/LOBSTER/trcbio.F90	(revision 2081)
+++ /branches/DEV_r2006_merge_TRA_TRC/NEMO/TOP_SRC/LOBSTER/trcbio.F90	(revision 2082)
@@ -81,5 +81,5 @@
       !!---------------------------------------------------------------------
 
-      IF( kt == nit000 ) THEN
+      IF( kt == nittrc000 ) THEN
          IF(lwp) WRITE(numout,*)
          IF(lwp) WRITE(numout,*) ' trc_bio: LOBSTER bio-model'
Index: /branches/DEV_r2006_merge_TRA_TRC/NEMO/TOP_SRC/LOBSTER/trcexp.F90
===================================================================
--- /branches/DEV_r2006_merge_TRA_TRC/NEMO/TOP_SRC/LOBSTER/trcexp.F90	(revision 2081)
+++ /branches/DEV_r2006_merge_TRA_TRC/NEMO/TOP_SRC/LOBSTER/trcexp.F90	(revision 2082)
@@ -60,5 +60,5 @@
       !!---------------------------------------------------------------------
 
-      IF( kt == nit000 ) THEN
+      IF( kt == nittrc000 ) THEN
          IF(lwp) WRITE(numout,*)
          IF(lwp) WRITE(numout,*) ' trc_exp: LOBSTER export'
Index: /branches/DEV_r2006_merge_TRA_TRC/NEMO/TOP_SRC/LOBSTER/trcopt.F90
===================================================================
--- /branches/DEV_r2006_merge_TRA_TRC/NEMO/TOP_SRC/LOBSTER/trcopt.F90	(revision 2081)
+++ /branches/DEV_r2006_merge_TRA_TRC/NEMO/TOP_SRC/LOBSTER/trcopt.F90	(revision 2082)
@@ -65,5 +65,5 @@
       !!---------------------------------------------------------------------
 
-      IF( kt == nit000 ) THEN
+      IF( kt == nittrc000 ) THEN
          IF(lwp) WRITE(numout,*)
          IF(lwp) WRITE(numout,*) ' trc_opt : LOBSTER optic-model'
Index: /branches/DEV_r2006_merge_TRA_TRC/NEMO/TOP_SRC/LOBSTER/trcsed.F90
===================================================================
--- /branches/DEV_r2006_merge_TRA_TRC/NEMO/TOP_SRC/LOBSTER/trcsed.F90	(revision 2081)
+++ /branches/DEV_r2006_merge_TRA_TRC/NEMO/TOP_SRC/LOBSTER/trcsed.F90	(revision 2082)
@@ -67,5 +67,5 @@
       !!---------------------------------------------------------------------
 
-      IF( kt == nit000 ) THEN
+      IF( kt == nittrc000 ) THEN
          IF(lwp) WRITE(numout,*)
          IF(lwp) WRITE(numout,*) ' trc_sed: LOBSTER sedimentation'
Index: /branches/DEV_r2006_merge_TRA_TRC/NEMO/TOP_SRC/PISCES/p4zche.F90
===================================================================
--- /branches/DEV_r2006_merge_TRA_TRC/NEMO/TOP_SRC/PISCES/p4zche.F90	(revision 2081)
+++ /branches/DEV_r2006_merge_TRA_TRC/NEMO/TOP_SRC/PISCES/p4zche.F90	(revision 2082)
@@ -181,8 +181,8 @@
 
             !                             ! SET ABSOLUTE TEMPERATURE
-            ztkel = tn(ji,jj,1) + 273.16
+            ztkel = tsn(ji,jj,1,jp_tem) + 273.16
             zqtt  = ztkel * 0.01
             zqtt2 = zqtt * zqtt
-            zsal  = sn(ji,jj,1) + (1.- tmask(ji,jj,1) ) * 35.
+            zsal  = tsn(ji,jj,1,jp_sal) + (1.- tmask(ji,jj,1) ) * 35.
             zlqtt = LOG( zqtt )
 
@@ -214,7 +214,7 @@
 
                ! SET ABSOLUTE TEMPERATURE
-               ztkel   = tn(ji,jj,jk) + 273.16
+               ztkel   = tsn(ji,jj,jk,jp_tem) + 273.16
                zqtt    = ztkel * 0.01
-               zsal    = sn(ji,jj,jk) + ( 1.-tmask(ji,jj,jk) ) * 35.
+               zsal    = tsn(ji,jj,jk,jp_sal) + ( 1.-tmask(ji,jj,jk) ) * 35.
                zsqrt  = SQRT( zsal )
                zsal15  = zsqrt * zsal
@@ -224,5 +224,5 @@
                zis2   = zis * zis
                zisqrt = SQRT( zis )
-               ztc     = tn(ji,jj,jk) + ( 1.- tmask(ji,jj,jk) ) * 20.
+               ztc     = tsn(ji,jj,jk,jp_tem) + ( 1.- tmask(ji,jj,jk) ) * 20.
 
                ! CHLORINITY (WOOSTER ET AL., 1969)
Index: /branches/DEV_r2006_merge_TRA_TRC/NEMO/TOP_SRC/PISCES/p4zflx.F90
===================================================================
--- /branches/DEV_r2006_merge_TRA_TRC/NEMO/TOP_SRC/PISCES/p4zflx.F90	(revision 2081)
+++ /branches/DEV_r2006_merge_TRA_TRC/NEMO/TOP_SRC/PISCES/p4zflx.F90	(revision 2082)
@@ -128,5 +128,5 @@
 !CDIR NOVERRCHK
          DO ji = 1, jpi
-            ztc  = MIN( 35., tn(ji,jj,1) )
+            ztc  = MIN( 35., tsn(ji,jj,1,jp_tem) )
             ztc2 = ztc * ztc
             ztc3 = ztc * ztc2 
Index: /branches/DEV_r2006_merge_TRA_TRC/NEMO/TOP_SRC/PISCES/p4zint.F90
===================================================================
--- /branches/DEV_r2006_merge_TRA_TRC/NEMO/TOP_SRC/PISCES/p4zint.F90	(revision 2081)
+++ /branches/DEV_r2006_merge_TRA_TRC/NEMO/TOP_SRC/PISCES/p4zint.F90	(revision 2082)
@@ -55,6 +55,6 @@
       ! -------------------------------------------
 
-      tgfunc (:,:,:) = EXP( 0.063913 * tn(:,:,:) )
-      tgfunc2(:,:,:) = EXP( 0.07608  * tn(:,:,:) )
+      tgfunc (:,:,:) = EXP( 0.063913 * tsn(:,:,:,jp_tem) )
+      tgfunc2(:,:,:) = EXP( 0.07608  * tsn(:,:,:,jp_tem) )
 
       ! Computation of the silicon dependant half saturation
Index: /branches/DEV_r2006_merge_TRA_TRC/NEMO/TOP_SRC/PISCES/p4zlim.F90
===================================================================
--- /branches/DEV_r2006_merge_TRA_TRC/NEMO/TOP_SRC/PISCES/p4zlim.F90	(revision 2081)
+++ /branches/DEV_r2006_merge_TRA_TRC/NEMO/TOP_SRC/PISCES/p4zlim.F90	(revision 2082)
@@ -161,5 +161,5 @@
          DO jj = 1, jpj
             DO ji = 1, jpi
-               ztemp = MAX( 0., tn(ji,jj,jk) )
+               ztemp = MAX( 0., tsn(ji,jj,jk,jp_tem) )
                xfracal(ji,jj,jk) = caco3r * xlimphy(ji,jj,jk)   &
                   &                       * MAX( 0.0001, ztemp / ( 2.+ ztemp ) )   &
Index: /branches/DEV_r2006_merge_TRA_TRC/NEMO/TOP_SRC/PISCES/p4zprod.F90
===================================================================
--- /branches/DEV_r2006_merge_TRA_TRC/NEMO/TOP_SRC/PISCES/p4zprod.F90	(revision 2081)
+++ /branches/DEV_r2006_merge_TRA_TRC/NEMO/TOP_SRC/PISCES/p4zprod.F90	(revision 2082)
@@ -147,5 +147,5 @@
                ! Computation of the P-I slope for nanos and diatoms
                IF( etot(ji,jj,jk) > 1.E-3 ) THEN
-                   ztn    = MAX( 0., tn(ji,jj,jk) - 15. )
+                   ztn    = MAX( 0., tsn(ji,jj,jk,jp_tem) - 15. )
                    zadap  = 0.+ 1.* ztn / ( 2.+ ztn )
                    zadap2 = 0.e0
Index: /branches/DEV_r2006_merge_TRA_TRC/NEMO/TOP_SRC/PISCES/p4zrem.F90
===================================================================
--- /branches/DEV_r2006_merge_TRA_TRC/NEMO/TOP_SRC/PISCES/p4zrem.F90	(revision 2081)
+++ /branches/DEV_r2006_merge_TRA_TRC/NEMO/TOP_SRC/PISCES/p4zrem.F90	(revision 2082)
@@ -287,6 +287,6 @@
                zsatur  = ( sio3eq(ji,jj,jk) - trn(ji,jj,jk,jpsil) ) / ( sio3eq(ji,jj,jk) + rtrn )
                zsatur  = MAX( rtrn, zsatur )
-               zsatur2 = zsatur * ( 1. + tn(ji,jj,jk) / 400.)**4
-               znusil  = 0.225  * ( 1. + tn(ji,jj,jk) / 15.) * zsatur + 0.775 * zsatur2**9
+               zsatur2 = zsatur * ( 1. + tsn(ji,jj,jk,jp_tem) / 400.)**4
+               znusil  = 0.225  * ( 1. + tsn(ji,jj,jk,jp_tem) / 15.) * zsatur + 0.775 * zsatur2**9
 #    if defined key_degrad
                zsiremin = xsirem * xstep * znusil * facvol(ji,jj,jk)
Index: /branches/DEV_r2006_merge_TRA_TRC/NEMO/TOP_SRC/PISCES/p4zsed.F90
===================================================================
--- /branches/DEV_r2006_merge_TRA_TRC/NEMO/TOP_SRC/PISCES/p4zsed.F90	(revision 2081)
+++ /branches/DEV_r2006_merge_TRA_TRC/NEMO/TOP_SRC/PISCES/p4zsed.F90	(revision 2082)
@@ -383,8 +383,8 @@
       imois2 = nmonth
 
-      ! 1. first call kt=nit000
+      ! 1. first call kt=nittrc000
       ! -----------------------
 
-      IF( kt == nit000 ) THEN
+      IF( kt == nittrc000 ) THEN
          ! initializations
          nflx1  = 0
@@ -402,5 +402,5 @@
       ! ----------------
 
-      IF( kt == nit000 .OR. imois /= nflx1 ) THEN
+      IF( kt == nittrc000 .OR. imois /= nflx1 ) THEN
 
          ! Calendar computation
@@ -423,13 +423,4 @@
          CALL iom_get ( numdust, jpdom_data, 'dust', dustmo(:,:,1), nflx1 )
          CALL iom_get ( numdust, jpdom_data, 'dust', dustmo(:,:,2), nflx2 )
-
-         IF(lwp .AND. nitend-nit000 <= 100 ) THEN
-            WRITE(numout,*)
-            WRITE(numout,*) ' read clio flx ok'
-            WRITE(numout,*)
-               WRITE(numout,*)
-               WRITE(numout,*) 'Clio month: ',nflx1,'  field: dust'
-               CALL prihre( dustmo(:,:,1),jpi,jpj,1,jpi,20,1,jpj,10,1e9,numout )
-         ENDIF
 
       ENDIF
Index: /branches/DEV_r2006_merge_TRA_TRC/NEMO/TOP_SRC/SED/par_sed.F90
===================================================================
--- /branches/DEV_r2006_merge_TRA_TRC/NEMO/TOP_SRC/SED/par_sed.F90	(revision 2081)
+++ /branches/DEV_r2006_merge_TRA_TRC/NEMO/TOP_SRC/SED/par_sed.F90	(revision 2082)
@@ -16,4 +16,6 @@
       jpjm1    =>   jpjm1 ,  & !: jpj - 1
       jpij     =>   jpij       !: jpi x jpj
+      jp_tem   =>   jp_tem     !: indice of temperature
+      jp_sal   =>   jp_sal     !: indice of salintity
 
 #if ! defined key_sed_off
Index: /branches/DEV_r2006_merge_TRA_TRC/NEMO/TOP_SRC/SED/sed.F90
===================================================================
--- /branches/DEV_r2006_merge_TRA_TRC/NEMO/TOP_SRC/SED/sed.F90	(revision 2081)
+++ /branches/DEV_r2006_merge_TRA_TRC/NEMO/TOP_SRC/SED/sed.F90	(revision 2082)
@@ -34,6 +34,5 @@
 
    USE oce , ONLY :            &
-      tn      =>    tn    ,  & !: pot. temperature (celsius)
-      sn      =>    sn         !: salinity (psu)
+      tsn      =>    tsn       & !: pot. temperature (celsius) and salinity (psu)
 
    USE trc, ONLY :  &
@@ -215,5 +214,4 @@
    INTEGER, PUBLIC :: &
      numsed = 27
-	
 #else
    !!======================================================================
Index: /branches/DEV_r2006_merge_TRA_TRC/NEMO/TOP_SRC/SED/seddta.F90
===================================================================
--- /branches/DEV_r2006_merge_TRA_TRC/NEMO/TOP_SRC/SED/seddta.F90	(revision 2081)
+++ /branches/DEV_r2006_merge_TRA_TRC/NEMO/TOP_SRC/SED/seddta.F90	(revision 2082)
@@ -131,12 +131,12 @@
                   trc_data(ji,jj,9 ) = sinking2(ji,jj,ikt)
                   trc_data(ji,jj,10) = sinkcal (ji,jj,ikt)
-                  trc_data(ji,jj,11) = tn      (ji,jj,ikt)
-                  trc_data(ji,jj,12) = sn      (ji,jj,ikt)
+                  trc_data(ji,jj,11) = tsn     (ji,jj,ikt,jp_tem)
+                  trc_data(ji,jj,12) = tsn     (ji,jj,ikt,jp_sal)
 #   else
                   trc_data(ji,jj,7 ) = sinksil (ji,jj,ikt)
                   trc_data(ji,jj,8 ) = sinking (ji,jj,ikt)
                   trc_data(ji,jj,9 ) = sinkcal (ji,jj,ikt)
-                  trc_data(ji,jj,10) = tn      (ji,jj,ikt)
-                  trc_data(ji,jj,11) = sn      (ji,jj,ikt)       
+                  trc_data(ji,jj,10) = tsn     (ji,jj,ikt,jp_tem)
+                  trc_data(ji,jj,11) = tsn     (ji,jj,ikt,jp_sal)       
 #   endif
                ENDIF
Index: /branches/DEV_r2006_merge_TRA_TRC/NEMO/TOP_SRC/TRP/trcadv.F90
===================================================================
--- /branches/DEV_r2006_merge_TRA_TRC/NEMO/TOP_SRC/TRP/trcadv.F90	(revision 2081)
+++ /branches/DEV_r2006_merge_TRA_TRC/NEMO/TOP_SRC/TRP/trcadv.F90	(revision 2082)
@@ -33,5 +33,8 @@
 
    PUBLIC   trc_adv    ! routine called by step module
+
    INTEGER ::   nadv   ! choice of the type of advection scheme
+   REAL(wp), DIMENSION(jpk) ::   r2dt  ! vertical profile time-step, = 2 rdttra
+      !                                ! except at nit000 (=rdttra) if neuler=0
 
    !! * Substitutions
@@ -64,4 +67,10 @@
       IF( kt == nittrc000 )   CALL trc_adv_ctl          ! initialisation & control of options
 
+      IF( neuler == 0 .AND. kt == nittrc000 ) THEN     ! at nit000
+         r2dt(:) =  rdttra(:) * FLOAT(nn_dttrc)          ! = rdtra (restarting with Euler time stepping)
+      ELSEIF( kt <= nittrc000 + nn_dttrc ) THEN          ! at nit000 or nit000+1
+         r2dt(:) = 2. * rdttra(:) * FLOAT(nn_dttrc)      ! = 2 rdttra (leapfrog)
+      ENDIF
+
       !                                                   ! effective transport
       DO jk = 1, jpkm1
@@ -78,28 +87,28 @@
       !
       SELECT CASE ( nadv )                            !==  compute advection trend and add it to general trend  ==!
-      CASE ( 1 )   ;    CALL tra_adv_cen2  ( kt, 'TRC', zun, zvn, zwn, trb, trn, tra, jptra )   !  2nd order centered
-      CASE ( 2 )   ;    CALL tra_adv_tvd   ( kt, 'TRC', zun, zvn, zwn, trb, trn, tra, jptra )   !  TVD 
-      CASE ( 3 )   ;    CALL tra_adv_muscl ( kt, 'TRC', zun, zvn, zwn, trb,      tra, jptra )   !  MUSCL 
-      CASE ( 4 )   ;    CALL tra_adv_muscl2( kt, 'TRC', zun, zvn, zwn, trb, trn, tra, jptra )   !  MUSCL2 
-      CASE ( 5 )   ;    CALL tra_adv_ubs   ( kt, 'TRC', zun, zvn, zwn, trb, trn, tra, jptra )   !  UBS 
-      CASE ( 6 )   ;    CALL tra_adv_qck   ( kt, 'TRC', zun, zvn, zwn, trb, trn, tra, jptra )   !  QUICKEST 
+      CASE ( 1 )   ;    CALL tra_adv_cen2  ( kt, 'TRC',       zun, zvn, zwn, trb, trn, tra, jptra )   !  2nd order centered
+      CASE ( 2 )   ;    CALL tra_adv_tvd   ( kt, 'TRC', r2dt, zun, zvn, zwn, trb, trn, tra, jptra )   !  TVD 
+      CASE ( 3 )   ;    CALL tra_adv_muscl ( kt, 'TRC', r2dt, zun, zvn, zwn, trb,      tra, jptra )   !  MUSCL 
+      CASE ( 4 )   ;    CALL tra_adv_muscl2( kt, 'TRC', r2dt, zun, zvn, zwn, trb, trn, tra, jptra )   !  MUSCL2 
+      CASE ( 5 )   ;    CALL tra_adv_ubs   ( kt, 'TRC', r2dt, zun, zvn, zwn, trb, trn, tra, jptra )   !  UBS 
+      CASE ( 6 )   ;    CALL tra_adv_qck   ( kt, 'TRC', r2dt, zun, zvn, zwn, trb, trn, tra, jptra )   !  QUICKEST 
       !
       CASE (-1 )                                      !==  esopa: test all possibility with control print  ==!
-         CALL tra_adv_cen2  ( kt, 'TRC', zun, zvn, zwn, trb, trn, tra, jptra )          
+         CALL tra_adv_cen2  ( kt, 'TRC',       zun, zvn, zwn, trb, trn, tra, jptra )          
          WRITE(charout, FMT="('adv1')")  ; CALL prt_ctl_trc_info(charout)
                                            CALL prt_ctl_trc(tab4d=tra, mask=tmask, clinfo=ctrcnm,clinfo2='trd')
-         CALL tra_adv_tvd   ( kt, 'TRC', zun, zvn, zwn, trb, trn, tra, jptra )          
+         CALL tra_adv_tvd   ( kt, 'TRC', r2dt, zun, zvn, zwn, trb, trn, tra, jptra )          
          WRITE(charout, FMT="('adv2')")  ; CALL prt_ctl_trc_info(charout)
                                            CALL prt_ctl_trc(tab4d=tra, mask=tmask, clinfo=ctrcnm,clinfo2='trd')
-         CALL tra_adv_muscl ( kt, 'TRC', zun, zvn, zwn, trb,      tra, jptra )          
+         CALL tra_adv_muscl ( kt, 'TRC', r2dt, zun, zvn, zwn, trb,      tra, jptra )          
          WRITE(charout, FMT="('adv3')")  ; CALL prt_ctl_trc_info(charout)
                                            CALL prt_ctl_trc(tab4d=tra, mask=tmask, clinfo=ctrcnm,clinfo2='trd')
-         CALL tra_adv_muscl2( kt, 'TRC', zun, zvn, zwn, trb, trn, tra, jptra )          
+         CALL tra_adv_muscl2( kt, 'TRC', r2dt, zun, zvn, zwn, trb, trn, tra, jptra )          
          WRITE(charout, FMT="('adv4')")  ; CALL prt_ctl_trc_info(charout)
                                            CALL prt_ctl_trc(tab4d=tra, mask=tmask, clinfo=ctrcnm,clinfo2='trd')
-         CALL tra_adv_ubs   ( kt, 'TRC', zun, zvn, zwn, trb, trn, tra, jptra )          
+         CALL tra_adv_ubs   ( kt, 'TRC', r2dt, zun, zvn, zwn, trb, trn, tra, jptra )          
          WRITE(charout, FMT="('adv5')")  ; CALL prt_ctl_trc_info(charout)
                                            CALL prt_ctl_trc(tab4d=tra, mask=tmask, clinfo=ctrcnm,clinfo2='trd')
-         CALL tra_adv_qck   ( kt, 'TRC', zun, zvn, zwn, trb, trn, tra, jptra )          
+         CALL tra_adv_qck   ( kt, 'TRC', r2dt, zun, zvn, zwn, trb, trn, tra, jptra )          
          WRITE(charout, FMT="('adv6')")  ; CALL prt_ctl_trc_info(charout)
                                            CALL prt_ctl_trc(tab4d=tra, mask=tmask, clinfo=ctrcnm,clinfo2='trd')
Index: /branches/DEV_r2006_merge_TRA_TRC/NEMO/TOP_SRC/TRP/trcnxt.F90
===================================================================
--- /branches/DEV_r2006_merge_TRA_TRC/NEMO/TOP_SRC/TRP/trcnxt.F90	(revision 2081)
+++ /branches/DEV_r2006_merge_TRA_TRC/NEMO/TOP_SRC/TRP/trcnxt.F90	(revision 2082)
@@ -44,5 +44,5 @@
    PUBLIC trc_nxt          ! routine called by step.F90
 
-  REAL(wp), DIMENSION(jpk) ::   r2dt_t
+  REAL(wp), DIMENSION(jpk) ::   r2dt
    !!----------------------------------------------------------------------
    !!   TOP 1.0 , LOCEAN-IPSL (2005) 
@@ -109,6 +109,6 @@
 
       ! set time step size (Euler/Leapfrog)
-      IF( neuler == 0 .AND. kt ==  nittrc000) THEN  ;  r2dt_t(:) =     rdttra(:) * FLOAT( nn_dttrc )  ! at nit000             (Euler)
-      ELSEIF( kt <= nittrc000 + 1 )           THEN  ;  r2dt_t(:) = 2.* rdttra(:) * FLOAT( nn_dttrc )  ! at nit000 or nit000+1 (Leapfrog)
+      IF( neuler == 0 .AND. kt ==  nittrc000) THEN  ;  r2dt(:) =     rdttra(:) * FLOAT( nn_dttrc )  ! at nit000             (Euler)
+      ELSEIF( kt <= nittrc000 + 1 )           THEN  ;  r2dt(:) = 2.* rdttra(:) * FLOAT( nn_dttrc )  ! at nit000 or nit000+1 (Leapfrog)
       ENDIF
 
@@ -133,5 +133,5 @@
          DO jn = 1, jptra
             DO jk = 1, jpkm1
-               zfact = 1.e0 / r2dt_t(jk)  
+               zfact = 1.e0 / r2dt(jk)  
                ztrdt(:,:,jk,jn) = ( trb(:,:,jk,jn) - ztrdt(:,:,jk,jn) ) * zfact 
                CALL trd_tra( kt, 'TRC', jn, jptra_trd_atf, ztrdt )
Index: /branches/DEV_r2006_merge_TRA_TRC/NEMO/TOP_SRC/TRP/trctrp.F90
===================================================================
--- /branches/DEV_r2006_merge_TRA_TRC/NEMO/TOP_SRC/TRP/trctrp.F90	(revision 2081)
+++ /branches/DEV_r2006_merge_TRA_TRC/NEMO/TOP_SRC/TRP/trctrp.F90	(revision 2082)
@@ -28,5 +28,5 @@
    USE trcrad          ! positivity                          (trc_rad routine)
    USE trcsbc          ! surface boundary condition          (trc_sbc routine)
-   USE zpshde          ! partial step: hor. derivative   (zps_hde_trc routine)
+   USE zpshde          ! partial step: hor. derivative       (zps_hde routine)
 
 #if defined key_agrif
@@ -74,5 +74,5 @@
 #endif
                                 CALL trc_zdf( kstp )            ! vertical mixing and after tracer fields
-         IF( ln_zps    )        CALL zps_hde_trc( kstp, jptra, trn, gtru, gtrv )  ! Partial steps: now horizontal gradient of passive
+         IF( ln_zps    )        CALL zps_hde( kstp, jptra, trn, gtru, gtrv )  ! Partial steps: now horizontal gradient of passive
                                                                 ! tracers at the bottom ocean level
                                 CALL trc_nxt( kstp )            ! tracer fields at next time step     
Index: /branches/DEV_r2006_merge_TRA_TRC/NEMO/TOP_SRC/oce_trc.F90
===================================================================
--- /branches/DEV_r2006_merge_TRA_TRC/NEMO/TOP_SRC/oce_trc.F90	(revision 2081)
+++ /branches/DEV_r2006_merge_TRA_TRC/NEMO/TOP_SRC/oce_trc.F90	(revision 2082)
@@ -173,9 +173,7 @@
    USE oce , ONLY :   l_traldf_rot => l_traldf_rot  !: rotated laplacian operator for lateral diffusion
 #if defined key_offline
-   USE oce , ONLY :   gtu     =>    gtu     !: t-, s- and rd horizontal gradient at u- and
-   USE oce , ONLY :   gsu     =>    gsu     !: v-points at bottom ocean level
+   USE oce , ONLY :   gtsu    =>    gtsu    !: t-, s- and rd horizontal gradient at u- and
+   USE oce , ONLY :   gtsv    =>    gtsv    !:
    USE oce , ONLY :   gru     =>    gru     !:
-   USE oce , ONLY :   gtv     =>    gtv     !:
-   USE oce , ONLY :   gsv     =>    gsv     !:
    USE oce , ONLY :   grv     =>    grv     !: 
 # if defined key_degrad
Index: /branches/DEV_r2006_merge_TRA_TRC/NEMO/TOP_SRC/trc.F90
===================================================================
--- /branches/DEV_r2006_merge_TRA_TRC/NEMO/TOP_SRC/trc.F90	(revision 2081)
+++ /branches/DEV_r2006_merge_TRA_TRC/NEMO/TOP_SRC/trc.F90	(revision 2082)
@@ -55,6 +55,4 @@
    !! passive tracers restart (input and output)
    !! ------------------------------------------  
-   INTEGER , PUBLIC  ::  nn_dttrc      !: frequency of step on passive tracers
-   INTEGER , PUBLIC  ::  nittrc000     !: first time step of passive tracers model
    LOGICAL , PUBLIC  ::  ln_rsttr      !: boolean term for restart i/o for passive tracers (namelist)
    LOGICAL , PUBLIC  ::  lrst_trc      !: logical to control the trc restart write
Index: /branches/DEV_r2006_merge_TRA_TRC/NEMO/TOP_SRC/trcini.F90
===================================================================
--- /branches/DEV_r2006_merge_TRA_TRC/NEMO/TOP_SRC/trcini.F90	(revision 2081)
+++ /branches/DEV_r2006_merge_TRA_TRC/NEMO/TOP_SRC/trcini.F90	(revision 2082)
@@ -29,5 +29,5 @@
    USE daymod
 #endif
-   USE zpshde          ! partial step: hor. derivative   (zps_hde_trc routine)
+   USE zpshde          ! partial step: hor. derivative   (zps_hde routine)
    USE in_out_manager  ! I/O manager
    USE prtctl_trc      ! Print control passive tracers (prt_ctl_trc_init routine)
@@ -49,7 +49,7 @@
 CONTAINS
    
-   SUBROUTINE trc_ini
+   SUBROUTINE trc_init
       !!---------------------------------------------------------------------
-      !!                     ***  ROUTINE trc_ini  ***
+      !!                     ***  ROUTINE trc_init  ***
       !!
       !! ** Purpose :   Initialization of the passive tracer fields 
@@ -67,5 +67,5 @@
 
       IF(lwp) WRITE(numout,*)
-      IF(lwp) WRITE(numout,*) 'trc_ini : initial set up of the passive tracers'
+      IF(lwp) WRITE(numout,*) 'trc_init : initial set up of the passive tracers'
       IF(lwp) WRITE(numout,*) '~~~~~~~'
 
@@ -138,5 +138,5 @@
       
       IF( ln_zps .AND. .NOT. lk_trc_c1d )   &              ! Partial steps: before horizontal gradient of passive
-      &                     CALL zps_hde_trc( nittrc000, jptra, trb, gtru, gtrv )       ! tracers at the bottom ocean level
+      &                     CALL zps_hde( nittrc000, jptra, trb, gtru, gtrv )       ! tracers at the bottom ocean level
 
 
@@ -170,5 +170,5 @@
       ENDIF
 
-   END SUBROUTINE trc_ini
+   END SUBROUTINE trc_init
 
 #else
@@ -177,6 +177,6 @@
    !!----------------------------------------------------------------------
 CONTAINS
-   SUBROUTINE trc_ini                      ! Dummy routine   
-   END SUBROUTINE trc_ini
+   SUBROUTINE trc_init                      ! Dummy routine   
+   END SUBROUTINE trc_init
 #endif
 
